Merge branch 'fs/test-prereq'
[git/debian.git] / t / test-lib.sh
blobb265c0a1fc3f3dc1235aad590b30e0c2aff932b5
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55 exit 1
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
60 # In t0000, we need to override test directories of nested testcases. In case
61 # the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
62 # reset this value to instead contain what the developer has specified. We thus
63 # have this knob to allow overriding the directory.
64 if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
65 then
66 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
69 # Disallow the use of abbreviated options in the test suite by default
70 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
71 then
72 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
73 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
76 # Explicitly set the default branch name for testing, to avoid the
77 # transitory "git init" warning under --verbose.
78 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
79 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
81 ################################################################
82 # It appears that people try to run tests without building...
83 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
84 if test $? != 1
85 then
86 if test -n "$GIT_TEST_INSTALLED"
87 then
88 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
89 else
90 echo >&2 'error: you do not seem to have built git yet.'
92 exit 1
95 store_arg_to=
96 opt_required_arg=
97 # $1: option string
98 # $2: name of the var where the arg will be stored
99 mark_option_requires_arg () {
100 if test -n "$opt_required_arg"
101 then
102 echo "error: options that require args cannot be bundled" \
103 "together: '$opt_required_arg' and '$1'" >&2
104 exit 1
106 opt_required_arg=$1
107 store_arg_to=$2
110 parse_option () {
111 local opt="$1"
113 case "$opt" in
114 -d|--d|--de|--deb|--debu|--debug)
115 debug=t ;;
116 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117 immediate=t ;;
118 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
119 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
121 mark_option_requires_arg "$opt" run_list
123 --run=*)
124 run_list=${opt#--*=} ;;
125 -h|--h|--he|--hel|--help)
126 help=t ;;
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t ;;
129 --verbose-only=*)
130 verbose_only=${opt#--*=}
132 -q|--q|--qu|--qui|--quie|--quiet)
133 # Ignore --quiet under a TAP::Harness. Saying how many tests
134 # passed without the ok/not ok details is always an error.
135 test -z "$HARNESS_ACTIVE" && quiet=t ;;
136 --with-dashes)
137 with_dashes=t ;;
138 --no-bin-wrappers)
139 no_bin_wrappers=t ;;
140 --no-color)
141 color= ;;
142 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
143 valgrind=memcheck
144 tee=t
146 --valgrind=*)
147 valgrind=${opt#--*=}
148 tee=t
150 --valgrind-only=*)
151 valgrind_only=${opt#--*=}
152 tee=t
154 --tee)
155 tee=t ;;
156 --root=*)
157 root=${opt#--*=} ;;
158 --chain-lint)
159 GIT_TEST_CHAIN_LINT=1 ;;
160 --no-chain-lint)
161 GIT_TEST_CHAIN_LINT=0 ;;
163 trace=t ;;
164 -V|--verbose-log)
165 verbose_log=t
166 tee=t
168 --write-junit-xml)
169 write_junit_xml=t
171 --stress)
172 stress=t ;;
173 --stress=*)
174 echo "error: --stress does not accept an argument: '$opt'" >&2
175 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
176 exit 1
178 --stress-jobs=*)
179 stress=t;
180 stress_jobs=${opt#--*=}
181 case "$stress_jobs" in
182 *[!0-9]*|0*|"")
183 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
184 exit 1
186 *) # Good.
188 esac
190 --stress-limit=*)
191 stress=t;
192 stress_limit=${opt#--*=}
193 case "$stress_limit" in
194 *[!0-9]*|0*|"")
195 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
196 exit 1
198 *) # Good.
200 esac
203 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
204 esac
207 # Parse options while taking care to leave $@ intact, so we will still
208 # have all the original command line options when executing the test
209 # script again for '--tee' and '--verbose-log' later.
210 for opt
212 if test -n "$store_arg_to"
213 then
214 eval $store_arg_to=\$opt
215 store_arg_to=
216 opt_required_arg=
217 continue
220 case "$opt" in
221 --*|-?)
222 parse_option "$opt" ;;
223 -?*)
224 # bundled short options must be fed separately to parse_option
225 opt=${opt#-}
226 while test -n "$opt"
228 extra=${opt#?}
229 this=${opt%$extra}
230 opt=$extra
231 parse_option "-$this"
232 done
235 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
236 esac
237 done
238 if test -n "$store_arg_to"
239 then
240 echo "error: $opt_required_arg requires an argument" >&2
241 exit 1
244 if test -n "$valgrind_only"
245 then
246 test -z "$valgrind" && valgrind=memcheck
247 test -z "$verbose" && verbose_only="$valgrind_only"
248 elif test -n "$valgrind"
249 then
250 test -z "$verbose_log" && verbose=t
253 if test -n "$stress"
254 then
255 verbose=t
256 trace=t
257 immediate=t
260 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
261 TEST_NAME="$(basename "$0" .sh)"
262 TEST_NUMBER="${TEST_NAME%%-*}"
263 TEST_NUMBER="${TEST_NUMBER#t}"
264 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
265 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
266 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
267 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
268 case "$TRASH_DIRECTORY" in
269 /*) ;; # absolute path is good
270 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
271 esac
273 # If --stress was passed, run this test repeatedly in several parallel loops.
274 if test "$GIT_TEST_STRESS_STARTED" = "done"
275 then
276 : # Don't stress test again.
277 elif test -n "$stress"
278 then
279 if test -n "$stress_jobs"
280 then
281 job_count=$stress_jobs
282 elif test -n "$GIT_TEST_STRESS_LOAD"
283 then
284 job_count="$GIT_TEST_STRESS_LOAD"
285 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
286 test -n "$job_count"
287 then
288 job_count=$((2 * $job_count))
289 else
290 job_count=8
293 mkdir -p "$TEST_RESULTS_DIR"
294 stressfail="$TEST_RESULTS_BASE.stress-failed"
295 rm -f "$stressfail"
297 stress_exit=0
298 trap '
299 kill $job_pids 2>/dev/null
300 wait
301 stress_exit=1
302 ' TERM INT HUP
304 job_pids=
305 job_nr=0
306 while test $job_nr -lt "$job_count"
309 GIT_TEST_STRESS_STARTED=done
310 GIT_TEST_STRESS_JOB_NR=$job_nr
311 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
313 trap '
314 kill $test_pid 2>/dev/null
315 wait
316 exit 1
317 ' TERM INT
319 cnt=1
320 while ! test -e "$stressfail" &&
321 { test -z "$stress_limit" ||
322 test $cnt -le $stress_limit ; }
324 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
325 test_pid=$!
327 if wait $test_pid
328 then
329 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
330 else
331 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
332 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
334 cnt=$(($cnt + 1))
335 done
337 job_pids="$job_pids $!"
338 job_nr=$(($job_nr + 1))
339 done
341 wait
343 if test -f "$stressfail"
344 then
345 stress_exit=1
346 echo "Log(s) of failed test run(s):"
347 for failed_job_nr in $(sort -n "$stressfail")
349 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
350 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
351 done
352 rm -rf "$TRASH_DIRECTORY.stress-failed"
353 # Move the last one.
354 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
357 exit $stress_exit
360 # if --tee was passed, write the output not only to the terminal, but
361 # additionally to the file test-results/$BASENAME.out, too.
362 if test "$GIT_TEST_TEE_STARTED" = "done"
363 then
364 : # do not redirect again
365 elif test -n "$tee"
366 then
367 mkdir -p "$TEST_RESULTS_DIR"
369 # Make this filename available to the sub-process in case it is using
370 # --verbose-log.
371 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
372 export GIT_TEST_TEE_OUTPUT_FILE
374 # Truncate before calling "tee -a" to get rid of the results
375 # from any previous runs.
376 >"$GIT_TEST_TEE_OUTPUT_FILE"
378 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
379 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
380 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
381 exit
384 if test -n "$trace" && test -n "$test_untraceable"
385 then
386 # '-x' tracing requested, but this test script can't be reliably
387 # traced, unless it is run with a Bash version supporting
388 # BASH_XTRACEFD (introduced in Bash v4.1).
390 # Perform this version check _after_ the test script was
391 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
392 # '--verbose-log', so the right shell is checked and the
393 # warning is issued only once.
394 if test -n "$BASH_VERSION" && eval '
395 test ${BASH_VERSINFO[0]} -gt 4 || {
396 test ${BASH_VERSINFO[0]} -eq 4 &&
397 test ${BASH_VERSINFO[1]} -ge 1
400 then
401 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
402 else
403 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
404 trace=
407 if test -n "$trace" && test -z "$verbose_log"
408 then
409 verbose=t
412 # Since bash 5.0, checkwinsize is enabled by default which does
413 # update the COLUMNS variable every time a non-builtin command
414 # completes, even for non-interactive shells.
415 # Disable that since we are aiming for repeatability.
416 test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
418 # For repeatability, reset the environment to known value.
419 # TERM is sanitized below, after saving color control sequences.
420 LANG=C
421 LC_ALL=C
422 PAGER=cat
423 TZ=UTC
424 COLUMNS=80
425 export LANG LC_ALL PAGER TZ COLUMNS
426 EDITOR=:
428 # A call to "unset" with no arguments causes at least Solaris 10
429 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
430 # deriving from the command substitution clustered with the other
431 # ones.
432 unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
433 my @env = keys %ENV;
434 my $ok = join("|", qw(
435 TRACE
436 DEBUG
437 TEST
438 .*_TEST
439 PROVE
440 VALGRIND
441 UNZIP
442 PERF_
443 CURL_VERBOSE
444 TRACE_CURL
446 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
447 print join("\n", @vars);
449 unset XDG_CACHE_HOME
450 unset XDG_CONFIG_HOME
451 unset GITPERLLIB
452 TEST_AUTHOR_LOCALNAME=author
453 TEST_AUTHOR_DOMAIN=example.com
454 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
455 GIT_AUTHOR_NAME='A U Thor'
456 GIT_AUTHOR_DATE='1112354055 +0200'
457 TEST_COMMITTER_LOCALNAME=committer
458 TEST_COMMITTER_DOMAIN=example.com
459 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
460 GIT_COMMITTER_NAME='C O Mitter'
461 GIT_COMMITTER_DATE='1112354055 +0200'
462 GIT_MERGE_VERBOSITY=5
463 GIT_MERGE_AUTOEDIT=no
464 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
465 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
466 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
467 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
468 export EDITOR
470 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
471 export GIT_DEFAULT_HASH
472 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
473 export GIT_TEST_MERGE_ALGORITHM
475 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
476 GIT_TRACE_BARE=1
477 export GIT_TRACE_BARE
479 # Use specific version of the index file format
480 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
481 then
482 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
483 export GIT_INDEX_VERSION
486 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
487 then
488 GIT_PERL_FATAL_WARNINGS=1
489 export GIT_PERL_FATAL_WARNINGS
492 # Add libc MALLOC and MALLOC_PERTURB test
493 # only if we are not executing the test with valgrind
494 if test -n "$valgrind" ||
495 test -n "$TEST_NO_MALLOC_CHECK"
496 then
497 setup_malloc_check () {
498 : nothing
500 teardown_malloc_check () {
501 : nothing
503 else
504 setup_malloc_check () {
505 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
506 export MALLOC_CHECK_ MALLOC_PERTURB_
508 teardown_malloc_check () {
509 unset MALLOC_CHECK_ MALLOC_PERTURB_
513 # Protect ourselves from common misconfiguration to export
514 # CDPATH into the environment
515 unset CDPATH
517 unset GREP_OPTIONS
518 unset UNZIP
520 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
521 1|2|true)
522 GIT_TRACE=4
524 esac
526 # Line feed
527 LF='
530 # Single quote
531 SQ=\'
533 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
534 # when case-folding filenames
535 u200c=$(printf '\342\200\214')
537 export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
539 # Each test should start with something like this, after copyright notices:
541 # test_description='Description of this test...
542 # This test checks if command xyzzy does the right thing...
544 # . ./test-lib.sh
545 test "x$TERM" != "xdumb" && (
546 test -t 1 &&
547 tput bold >/dev/null 2>&1 &&
548 tput setaf 1 >/dev/null 2>&1 &&
549 tput sgr0 >/dev/null 2>&1
550 ) &&
551 color=t
553 if test -n "$color"
554 then
555 # Save the color control sequences now rather than run tput
556 # each time say_color() is called. This is done for two
557 # reasons:
558 # * TERM will be changed to dumb
559 # * HOME will be changed to a temporary directory and tput
560 # might need to read ~/.terminfo from the original HOME
561 # directory to get the control sequences
562 # Note: This approach assumes the control sequences don't end
563 # in a newline for any terminal of interest (command
564 # substitutions strip trailing newlines). Given that most
565 # (all?) terminals in common use are related to ECMA-48, this
566 # shouldn't be a problem.
567 say_color_error=$(tput bold; tput setaf 1) # bold red
568 say_color_skip=$(tput setaf 4) # blue
569 say_color_warn=$(tput setaf 3) # brown/yellow
570 say_color_pass=$(tput setaf 2) # green
571 say_color_info=$(tput setaf 6) # cyan
572 say_color_reset=$(tput sgr0)
573 say_color_="" # no formatting for normal text
574 say_color () {
575 test -z "$1" && test -n "$quiet" && return
576 eval "say_color_color=\$say_color_$1"
577 shift
578 printf "%s\\n" "$say_color_color$*$say_color_reset"
580 else
581 say_color() {
582 test -z "$1" && test -n "$quiet" && return
583 shift
584 printf "%s\n" "$*"
588 USER_TERM="$TERM"
589 TERM=dumb
590 export TERM USER_TERM
592 # What is written by tests to stdout and stderr is sent to different places
593 # depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
594 # with --tee option, etc.). We save the original stdin to FD #6 and stdout and
595 # stderr to #5 and #7, so that the test framework can use them (e.g. for
596 # printing errors within the test framework) independently of the test mode.
597 exec 5>&1
598 exec 6<&0
599 exec 7>&2
601 _error_exit () {
602 finalize_junit_xml
603 GIT_EXIT_OK=t
604 exit 1
607 error () {
608 say_color error "error: $*"
609 _error_exit
612 BUG () {
613 error >&7 "bug in the test script: $*"
616 BAIL_OUT () {
617 test $# -ne 1 && BUG "1 param"
619 # Do not change "Bail out! " string. It's part of TAP syntax:
620 # https://testanything.org/tap-specification.html
621 local bail_out="Bail out! "
622 local message="$1"
624 say_color >&5 error $bail_out "$message"
625 _error_exit
628 say () {
629 say_color info "$*"
632 if test -n "$HARNESS_ACTIVE"
633 then
634 if test "$verbose" = t || test -n "$verbose_only"
635 then
636 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
640 test "${test_description}" != "" ||
641 error "Test script did not set test_description."
643 if test "$help" = "t"
644 then
645 printf '%s\n' "$test_description"
646 exit 0
649 if test "$verbose_log" = "t"
650 then
651 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
652 elif test "$verbose" = "t"
653 then
654 exec 4>&2 3>&1
655 else
656 exec 4>/dev/null 3>/dev/null
659 # Send any "-x" output directly to stderr to avoid polluting tests
660 # which capture stderr. We can do this unconditionally since it
661 # has no effect if tracing isn't turned on.
663 # Note that this sets up the trace fd as soon as we assign the variable, so it
664 # must come after the creation of descriptor 4 above. Likewise, we must never
665 # unset this, as it has the side effect of closing descriptor 4, which we
666 # use to show verbose tests to the user.
668 # Note also that we don't need or want to export it. The tracing is local to
669 # this shell, and we would not want to influence any shells we exec.
670 BASH_XTRACEFD=4
672 test_failure=0
673 test_count=0
674 test_fixed=0
675 test_broken=0
676 test_success=0
678 test_missing_prereq=
680 test_external_has_tap=0
682 die () {
683 code=$?
684 # This is responsible for running the atexit commands even when a
685 # test script run with '--immediate' fails, or when the user hits
686 # ctrl-C, i.e. when 'test_done' is not invoked at all.
687 test_atexit_handler || code=$?
688 if test -n "$GIT_EXIT_OK"
689 then
690 exit $code
691 else
692 echo >&5 "FATAL: Unexpected exit with code $code"
693 exit 1
697 GIT_EXIT_OK=
698 trap 'die' EXIT
699 # Disable '-x' tracing, because with some shells, notably dash, it
700 # prevents running the cleanup commands when a test script run with
701 # '--verbose-log -x' is interrupted.
702 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
704 # The user-facing functions are loaded from a separate file so that
705 # test_perf subshells can have them too
706 . "$TEST_DIRECTORY/test-lib-functions.sh"
708 # You are not expected to call test_ok_ and test_failure_ directly, use
709 # the test_expect_* functions instead.
711 test_ok_ () {
712 if test -n "$write_junit_xml"
713 then
714 write_junit_xml_testcase "$*"
716 test_success=$(($test_success + 1))
717 say_color "" "ok $test_count - $@"
720 test_failure_ () {
721 if test -n "$write_junit_xml"
722 then
723 junit_insert="<failure message=\"not ok $test_count -"
724 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
725 junit_insert="$junit_insert $(xml_attr_encode \
726 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
727 then
728 test-tool path-utils skip-n-bytes \
729 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
730 else
731 printf '%s\n' "$@" | sed 1d
732 fi)")"
733 junit_insert="$junit_insert</failure>"
734 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
735 then
736 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
737 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
739 write_junit_xml_testcase "$1" " $junit_insert"
741 test_failure=$(($test_failure + 1))
742 say_color error "not ok $test_count - $1"
743 shift
744 printf '%s\n' "$*" | sed -e 's/^/# /'
745 test "$immediate" = "" || _error_exit
748 test_known_broken_ok_ () {
749 if test -n "$write_junit_xml"
750 then
751 write_junit_xml_testcase "$* (breakage fixed)"
753 test_fixed=$(($test_fixed+1))
754 say_color error "ok $test_count - $@ # TODO known breakage vanished"
757 test_known_broken_failure_ () {
758 if test -n "$write_junit_xml"
759 then
760 write_junit_xml_testcase "$* (known breakage)"
762 test_broken=$(($test_broken+1))
763 say_color warn "not ok $test_count - $@ # TODO known breakage"
766 test_debug () {
767 test "$debug" = "" || eval "$1"
770 match_pattern_list () {
771 arg="$1"
772 shift
773 test -z "$*" && return 1
774 # We need to use "$*" to get field-splitting, but we want to
775 # disable globbing, since we are matching against an arbitrary
776 # $arg, not what's in the filesystem. Using "set -f" accomplishes
777 # that, but we must do it in a subshell to avoid impacting the
778 # rest of the script. The exit value of the subshell becomes
779 # the function's return value.
781 set -f
782 for pattern_ in $*
784 case "$arg" in
785 $pattern_)
786 exit 0
788 esac
789 done
790 exit 1
794 match_test_selector_list () {
795 operation="$1"
796 shift
797 title="$1"
798 shift
799 arg="$1"
800 shift
801 test -z "$1" && return 0
803 # Commas are accepted as separators.
804 OLDIFS=$IFS
805 IFS=','
806 set -- $1
807 IFS=$OLDIFS
809 # If the first selector is negative we include by default.
810 include=
811 case "$1" in
812 !*) include=t ;;
813 esac
815 for selector
817 orig_selector=$selector
819 positive=t
820 case "$selector" in
822 positive=
823 selector=${selector##?}
825 esac
827 test -z "$selector" && continue
829 case "$selector" in
830 *-*)
831 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
832 then
833 echo "error: $operation: invalid non-numeric in range" \
834 "start: '$orig_selector'" >&2
835 exit 1
837 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
838 then
839 echo "error: $operation: invalid non-numeric in range" \
840 "end: '$orig_selector'" >&2
841 exit 1
845 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
846 then
847 case "$title" in *${selector}*)
848 include=$positive
850 esac
851 continue
853 esac
855 # Short cut for "obvious" cases
856 test -z "$include" && test -z "$positive" && continue
857 test -n "$include" && test -n "$positive" && continue
859 case "$selector" in
861 if test $arg -le ${selector#-}
862 then
863 include=$positive
867 if test $arg -ge ${selector%-}
868 then
869 include=$positive
872 *-*)
873 if test ${selector%%-*} -le $arg \
874 && test $arg -le ${selector#*-}
875 then
876 include=$positive
880 if test $arg -eq $selector
881 then
882 include=$positive
885 esac
886 done
888 test -n "$include"
891 maybe_teardown_verbose () {
892 test -z "$verbose_only" && return
893 exec 4>/dev/null 3>/dev/null
894 verbose=
897 last_verbose=t
898 maybe_setup_verbose () {
899 test -z "$verbose_only" && return
900 if match_pattern_list $test_count "$verbose_only"
901 then
902 exec 4>&2 3>&1
903 # Emit a delimiting blank line when going from
904 # non-verbose to verbose. Within verbose mode the
905 # delimiter is printed by test_expect_*. The choice
906 # of the initial $last_verbose is such that before
907 # test 1, we do not print it.
908 test -z "$last_verbose" && echo >&3 ""
909 verbose=t
910 else
911 exec 4>/dev/null 3>/dev/null
912 verbose=
914 last_verbose=$verbose
917 maybe_teardown_valgrind () {
918 test -z "$GIT_VALGRIND" && return
919 GIT_VALGRIND_ENABLED=
922 maybe_setup_valgrind () {
923 test -z "$GIT_VALGRIND" && return
924 if test -z "$valgrind_only"
925 then
926 GIT_VALGRIND_ENABLED=t
927 return
929 GIT_VALGRIND_ENABLED=
930 if match_pattern_list $test_count "$valgrind_only"
931 then
932 GIT_VALGRIND_ENABLED=t
936 trace_level_=0
937 want_trace () {
938 test "$trace" = t && {
939 test "$verbose" = t || test "$verbose_log" = t
943 # This is a separate function because some tests use
944 # "return" to end a test_expect_success block early
945 # (and we want to make sure we run any cleanup like
946 # "set +x").
947 test_eval_inner_ () {
948 # Do not add anything extra (including LF) after '$*'
949 eval "
950 want_trace && trace_level_=$(($trace_level_+1)) && set -x
954 test_eval_ () {
955 # If "-x" tracing is in effect, then we want to avoid polluting stderr
956 # with non-test commands. But once in "set -x" mode, we cannot prevent
957 # the shell from printing the "set +x" to turn it off (nor the saving
958 # of $? before that). But we can make sure that the output goes to
959 # /dev/null.
961 # There are a few subtleties here:
963 # - we have to redirect descriptor 4 in addition to 2, to cover
964 # BASH_XTRACEFD
966 # - the actual eval has to come before the redirection block (since
967 # it needs to see descriptor 4 to set up its stderr)
969 # - likewise, any error message we print must be outside the block to
970 # access descriptor 4
972 # - checking $? has to come immediately after the eval, but it must
973 # be _inside_ the block to avoid polluting the "set -x" output
976 test_eval_inner_ "$@" </dev/null >&3 2>&4
978 test_eval_ret_=$?
979 if want_trace
980 then
981 test 1 = $trace_level_ && set +x
982 trace_level_=$(($trace_level_-1))
984 } 2>/dev/null 4>&2
986 if test "$test_eval_ret_" != 0 && want_trace
987 then
988 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
990 return $test_eval_ret_
993 test_run_ () {
994 test_cleanup=:
995 expecting_failure=$2
997 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
998 # turn off tracing for this test-eval, as it simply creates
999 # confusing noise in the "-x" output
1000 trace_tmp=$trace
1001 trace=
1002 # 117 is magic because it is unlikely to match the exit
1003 # code of other programs
1004 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)" ||
1006 test "${GIT_TEST_CHAIN_LINT_HARDER:-${GIT_TEST_CHAIN_LINT_HARDER_DEFAULT:-1}}" != 0 &&
1007 $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!')
1009 then
1010 BUG "broken &&-chain or run-away HERE-DOC: $1"
1012 trace=$trace_tmp
1015 setup_malloc_check
1016 test_eval_ "$1"
1017 eval_ret=$?
1018 teardown_malloc_check
1020 if test -z "$immediate" || test $eval_ret = 0 ||
1021 test -n "$expecting_failure" && test "$test_cleanup" != ":"
1022 then
1023 setup_malloc_check
1024 test_eval_ "$test_cleanup"
1025 teardown_malloc_check
1027 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1028 then
1029 echo ""
1031 return "$eval_ret"
1034 test_start_ () {
1035 test_count=$(($test_count+1))
1036 maybe_setup_verbose
1037 maybe_setup_valgrind
1038 if test -n "$write_junit_xml"
1039 then
1040 junit_start=$(test-tool date getnanos)
1044 test_finish_ () {
1045 echo >&3 ""
1046 maybe_teardown_valgrind
1047 maybe_teardown_verbose
1048 if test -n "$GIT_TEST_TEE_OFFSET"
1049 then
1050 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1051 "$GIT_TEST_TEE_OUTPUT_FILE")
1055 test_skip () {
1056 to_skip=
1057 skipped_reason=
1058 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
1059 then
1060 to_skip=t
1061 skipped_reason="GIT_SKIP_TESTS"
1063 if test -z "$to_skip" && test -n "$run_list" &&
1064 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1065 then
1066 to_skip=t
1067 skipped_reason="--run"
1069 if test -z "$to_skip" && test -n "$test_prereq" &&
1070 ! test_have_prereq "$test_prereq"
1071 then
1072 to_skip=t
1074 of_prereq=
1075 if test "$missing_prereq" != "$test_prereq"
1076 then
1077 of_prereq=" of $test_prereq"
1079 skipped_reason="missing $missing_prereq${of_prereq}"
1081 # Keep a list of all the missing prereq for result aggregation
1082 if test -z "$missing_prereq"
1083 then
1084 test_missing_prereq=$missing_prereq
1085 else
1086 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1090 case "$to_skip" in
1092 if test -n "$write_junit_xml"
1093 then
1094 message="$(xml_attr_encode "$skipped_reason")"
1095 write_junit_xml_testcase "$1" \
1096 " <skipped message=\"$message\" />"
1099 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1100 : true
1103 false
1105 esac
1108 # stub; perf-lib overrides it
1109 test_at_end_hook_ () {
1113 write_junit_xml () {
1114 case "$1" in
1115 --truncate)
1116 >"$junit_xml_path"
1117 junit_have_testcase=
1118 shift
1120 esac
1121 printf '%s\n' "$@" >>"$junit_xml_path"
1124 xml_attr_encode () {
1125 printf '%s\n' "$@" | test-tool xml-encode
1128 write_junit_xml_testcase () {
1129 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1130 shift
1131 junit_attrs="$junit_attrs classname=\"$this_test\""
1132 junit_attrs="$junit_attrs time=\"$(test-tool \
1133 date getnanos $junit_start)\""
1134 write_junit_xml "$(printf '%s\n' \
1135 " <testcase $junit_attrs>" "$@" " </testcase>")"
1136 junit_have_testcase=t
1139 finalize_junit_xml () {
1140 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1141 then
1142 test -n "$junit_have_testcase" || {
1143 junit_start=$(test-tool date getnanos)
1144 write_junit_xml_testcase "all tests skipped"
1147 # adjust the overall time
1148 junit_time=$(test-tool date getnanos $junit_suite_start)
1149 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1150 -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1151 -e '/^ *<\/testsuite/d' \
1152 <"$junit_xml_path" >"$junit_xml_path.new"
1153 mv "$junit_xml_path.new" "$junit_xml_path"
1155 write_junit_xml " </testsuite>" "</testsuites>"
1156 write_junit_xml=
1160 test_atexit_cleanup=:
1161 test_atexit_handler () {
1162 # In a succeeding test script 'test_atexit_handler' is invoked
1163 # twice: first from 'test_done', then from 'die' in the trap on
1164 # EXIT.
1165 # This condition and resetting 'test_atexit_cleanup' below makes
1166 # sure that the registered cleanup commands are run only once.
1167 test : != "$test_atexit_cleanup" || return 0
1169 setup_malloc_check
1170 test_eval_ "$test_atexit_cleanup"
1171 test_atexit_cleanup=:
1172 teardown_malloc_check
1175 test_done () {
1176 GIT_EXIT_OK=t
1178 # Run the atexit commands _before_ the trash directory is
1179 # removed, so the commands can access pidfiles and socket files.
1180 test_atexit_handler
1182 finalize_junit_xml
1184 if test -z "$HARNESS_ACTIVE"
1185 then
1186 mkdir -p "$TEST_RESULTS_DIR"
1188 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1189 total $test_count
1190 success $test_success
1191 fixed $test_fixed
1192 broken $test_broken
1193 failed $test_failure
1194 missing_prereq $test_missing_prereq
1199 if test "$test_fixed" != 0
1200 then
1201 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1203 if test "$test_broken" != 0
1204 then
1205 say_color warn "# still have $test_broken known breakage(s)"
1207 if test "$test_broken" != 0 || test "$test_fixed" != 0
1208 then
1209 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1210 msg="remaining $test_remaining test(s)"
1211 else
1212 test_remaining=$test_count
1213 msg="$test_count test(s)"
1215 case "$test_failure" in
1217 if test $test_external_has_tap -eq 0
1218 then
1219 if test $test_remaining -gt 0
1220 then
1221 say_color pass "# passed all $msg"
1224 # Maybe print SKIP message
1225 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1226 case "$test_count" in
1228 say "1..$test_count${skip_all:+ $skip_all}"
1231 test -z "$skip_all" ||
1232 say_color warn "$skip_all"
1233 say "1..$test_count"
1235 esac
1238 if test -z "$debug" && test -n "$remove_trash"
1239 then
1240 test -d "$TRASH_DIRECTORY" ||
1241 error "Tests passed but trash directory already removed before test cleanup; aborting"
1243 cd "$TRASH_DIRECTORY/.." &&
1244 rm -fr "$TRASH_DIRECTORY" || {
1245 # try again in a bit
1246 sleep 5;
1247 rm -fr "$TRASH_DIRECTORY"
1248 } ||
1249 error "Tests passed but test cleanup failed; aborting"
1251 test_at_end_hook_
1253 exit 0 ;;
1256 if test $test_external_has_tap -eq 0
1257 then
1258 say_color error "# failed $test_failure among $msg"
1259 say "1..$test_count"
1262 exit 1 ;;
1264 esac
1267 if test -n "$valgrind"
1268 then
1269 make_symlink () {
1270 test -h "$2" &&
1271 test "$1" = "$(readlink "$2")" || {
1272 # be super paranoid
1273 if mkdir "$2".lock
1274 then
1275 rm -f "$2" &&
1276 ln -s "$1" "$2" &&
1277 rm -r "$2".lock
1278 else
1279 while test -d "$2".lock
1281 say "Waiting for lock on $2."
1282 sleep 1
1283 done
1288 make_valgrind_symlink () {
1289 # handle only executables, unless they are shell libraries that
1290 # need to be in the exec-path.
1291 test -x "$1" ||
1292 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1293 return;
1295 base=$(basename "$1")
1296 case "$base" in
1297 test-*)
1298 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1301 symlink_target="$GIT_BUILD_DIR/$base"
1303 esac
1304 # do not override scripts
1305 if test -x "$symlink_target" &&
1306 test ! -d "$symlink_target" &&
1307 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1308 then
1309 symlink_target=../valgrind.sh
1311 case "$base" in
1312 *.sh|*.perl)
1313 symlink_target=../unprocessed-script
1314 esac
1315 # create the link, or replace it if it is out of date
1316 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1319 # override all git executables in TEST_DIRECTORY/..
1320 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1321 mkdir -p "$GIT_VALGRIND"/bin
1322 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1324 make_valgrind_symlink $file
1325 done
1326 # special-case the mergetools loadables
1327 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1328 OLDIFS=$IFS
1329 IFS=:
1330 for path in $PATH
1332 ls "$path"/git-* 2> /dev/null |
1333 while read file
1335 make_valgrind_symlink "$file"
1336 done
1337 done
1338 IFS=$OLDIFS
1339 PATH=$GIT_VALGRIND/bin:$PATH
1340 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1341 export GIT_VALGRIND
1342 GIT_VALGRIND_MODE="$valgrind"
1343 export GIT_VALGRIND_MODE
1344 GIT_VALGRIND_ENABLED=t
1345 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1346 export GIT_VALGRIND_ENABLED
1347 elif test -n "$GIT_TEST_INSTALLED"
1348 then
1349 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1350 error "Cannot run git from $GIT_TEST_INSTALLED."
1351 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1352 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1353 else # normal case, use ../bin-wrappers only unless $with_dashes:
1354 if test -n "$no_bin_wrappers"
1355 then
1356 with_dashes=t
1357 else
1358 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1359 if ! test -x "$git_bin_dir/git"
1360 then
1361 if test -z "$with_dashes"
1362 then
1363 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1365 with_dashes=t
1367 PATH="$git_bin_dir:$PATH"
1369 GIT_EXEC_PATH=$GIT_BUILD_DIR
1370 if test -n "$with_dashes"
1371 then
1372 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1375 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1376 GIT_CONFIG_NOSYSTEM=1
1377 GIT_ATTR_NOSYSTEM=1
1378 GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1379 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
1381 if test -z "$GIT_TEST_CMP"
1382 then
1383 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1384 then
1385 GIT_TEST_CMP="$DIFF -c"
1386 else
1387 GIT_TEST_CMP="$DIFF -u"
1391 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1392 export GITPERLLIB
1393 test -d "$GIT_BUILD_DIR"/templates/blt || {
1394 error "You haven't built things yet, have you?"
1397 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1398 then
1399 echo >&2 'You need to build test-tool:'
1400 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1401 exit 1
1404 # Are we running this test at all?
1405 remove_trash=
1406 this_test=${0##*/}
1407 this_test=${this_test%%-*}
1408 if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
1409 then
1410 say_color info >&3 "skipping test $this_test altogether"
1411 skip_all="skip all tests in $this_test"
1412 test_done
1415 # skip non-whitelisted tests when compiled with SANITIZE=leak
1416 if test -n "$SANITIZE_LEAK"
1417 then
1418 if test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1419 then
1420 # We need to see it in "git env--helper" (via
1421 # test_bool_env)
1422 export TEST_PASSES_SANITIZE_LEAK
1424 if ! test_bool_env TEST_PASSES_SANITIZE_LEAK false
1425 then
1426 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1427 test_done
1430 elif test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1431 then
1432 BAIL_OUT "GIT_TEST_PASSING_SANITIZE_LEAK=true has no effect except when compiled with SANITIZE=leak"
1435 # Last-minute variable setup
1436 USER_HOME="$HOME"
1437 HOME="$TRASH_DIRECTORY"
1438 GNUPGHOME="$HOME/gnupg-home-not-used"
1439 export HOME GNUPGHOME USER_HOME
1441 # "rm -rf" existing trash directory, even if a previous run left it
1442 # with bad permissions.
1443 remove_trash_directory () {
1444 dir="$1"
1445 if ! rm -rf "$dir" 2>/dev/null
1446 then
1447 chmod -R u+rwx "$dir"
1448 rm -rf "$dir"
1450 ! test -d "$dir"
1453 # Test repository
1454 remove_trash_directory "$TRASH_DIRECTORY" || {
1455 GIT_EXIT_OK=t
1456 echo >&5 "FATAL: Cannot prepare test area"
1457 exit 1
1460 remove_trash=t
1461 if test -z "$TEST_NO_CREATE_REPO"
1462 then
1463 git init "$TRASH_DIRECTORY" >&3 2>&4 ||
1464 error "cannot run git init"
1465 else
1466 mkdir -p "$TRASH_DIRECTORY"
1469 # Use -P to resolve symlinks in our working directory so that the cwd
1470 # in subprocesses like git equals our $PWD (for pathname comparisons).
1471 cd -P "$TRASH_DIRECTORY" || exit 1
1473 if test -n "$write_junit_xml"
1474 then
1475 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1476 mkdir -p "$junit_xml_dir"
1477 junit_xml_base=${0##*/}
1478 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1479 junit_attrs="name=\"${junit_xml_base%.sh}\""
1480 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1481 date +%Y-%m-%dT%H:%M:%S)\""
1482 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1483 junit_suite_start=$(test-tool date getnanos)
1484 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1485 then
1486 GIT_TEST_TEE_OFFSET=0
1490 # Convenience
1491 # A regexp to match 5 and 35 hexdigits
1492 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1493 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1495 test_oid_init
1497 ZERO_OID=$(test_oid zero)
1498 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1499 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1500 EMPTY_TREE=$(test_oid empty_tree)
1501 EMPTY_BLOB=$(test_oid empty_blob)
1503 # Provide an implementation of the 'yes' utility; the upper bound
1504 # limit is there to help Windows that cannot stop this loop from
1505 # wasting cycles when the downstream stops reading, so do not be
1506 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1507 # limit the output of the yes utility", 2016-02-02)
1508 yes () {
1509 if test $# = 0
1510 then
1512 else
1513 y="$*"
1517 while test $i -lt 99
1519 echo "$y"
1520 i=$(($i+1))
1521 done
1524 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1525 # thus needs to be set up really early, and set an internal variable
1526 # for convenience so the hot test_set_prereq() codepath doesn't need
1527 # to call "git env--helper" (via test_bool_env). Only do that work
1528 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1529 GIT_TEST_FAIL_PREREQS_INTERNAL=
1530 if test -n "$GIT_TEST_FAIL_PREREQS"
1531 then
1532 if test_bool_env GIT_TEST_FAIL_PREREQS false
1533 then
1534 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1535 test_set_prereq FAIL_PREREQS
1537 else
1538 test_lazy_prereq FAIL_PREREQS '
1539 test_bool_env GIT_TEST_FAIL_PREREQS false
1543 # Fix some commands on Windows, and other OS-specific things
1544 uname_s=$(uname -s)
1545 case $uname_s in
1546 *MINGW*)
1547 # Windows has its own (incompatible) sort and find
1548 sort () {
1549 /usr/bin/sort "$@"
1551 find () {
1552 /usr/bin/find "$@"
1554 # git sees Windows-style pwd
1555 pwd () {
1556 builtin pwd -W
1558 # no POSIX permissions
1559 # backslashes in pathspec are converted to '/'
1560 # exec does not inherit the PID
1561 test_set_prereq MINGW
1562 test_set_prereq NATIVE_CRLF
1563 test_set_prereq SED_STRIPS_CR
1564 test_set_prereq GREP_STRIPS_CR
1565 test_set_prereq WINDOWS
1566 GIT_TEST_CMP=mingw_test_cmp
1568 *CYGWIN*)
1569 test_set_prereq POSIXPERM
1570 test_set_prereq EXECKEEPSPID
1571 test_set_prereq CYGWIN
1572 test_set_prereq SED_STRIPS_CR
1573 test_set_prereq GREP_STRIPS_CR
1574 test_set_prereq WINDOWS
1577 test_set_prereq POSIXPERM
1578 test_set_prereq BSLASHPSPEC
1579 test_set_prereq EXECKEEPSPID
1581 esac
1583 # Detect arches where a few things don't work
1584 uname_m=$(uname -m)
1585 case $uname_m in
1586 parisc* | hppa*)
1587 test_set_prereq HPPA
1589 esac
1591 test_set_prereq REFFILES
1593 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1594 test -z "$NO_PERL" && test_set_prereq PERL
1595 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1596 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1597 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1598 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1599 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1600 test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
1602 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1603 then
1604 GIT_TEST_CHECK_CACHE_TREE=true
1605 export GIT_TEST_CHECK_CACHE_TREE
1608 test_lazy_prereq PIPE '
1609 # test whether the filesystem supports FIFOs
1610 test_have_prereq !MINGW,!CYGWIN &&
1611 rm -f testfifo && mkfifo testfifo
1614 test_lazy_prereq SYMLINKS '
1615 # test whether the filesystem supports symbolic links
1616 ln -s x y && test -h y
1619 test_lazy_prereq SYMLINKS_WINDOWS '
1620 # test whether symbolic links are enabled on Windows
1621 test_have_prereq MINGW &&
1622 cmd //c "mklink y x" &> /dev/null && test -h y
1625 test_lazy_prereq FILEMODE '
1626 test "$(git config --bool core.filemode)" = true
1629 test_lazy_prereq CASE_INSENSITIVE_FS '
1630 echo good >CamelCase &&
1631 echo bad >camelcase &&
1632 test "$(cat CamelCase)" != good
1635 test_lazy_prereq FUNNYNAMES '
1636 test_have_prereq !MINGW &&
1637 touch -- \
1638 "FUNNYNAMES tab embedded" \
1639 "FUNNYNAMES \"quote embedded\"" \
1640 "FUNNYNAMES newline
1641 embedded" 2>/dev/null &&
1642 rm -- \
1643 "FUNNYNAMES tab embedded" \
1644 "FUNNYNAMES \"quote embedded\"" \
1645 "FUNNYNAMES newline
1646 embedded" 2>/dev/null
1649 test_lazy_prereq UTF8_NFD_TO_NFC '
1650 # check whether FS converts nfd unicode to nfc
1651 auml=$(printf "\303\244")
1652 aumlcdiar=$(printf "\141\314\210")
1653 >"$auml" &&
1654 test -f "$aumlcdiar"
1657 test_lazy_prereq AUTOIDENT '
1658 sane_unset GIT_AUTHOR_NAME &&
1659 sane_unset GIT_AUTHOR_EMAIL &&
1660 git var GIT_AUTHOR_IDENT
1663 test_lazy_prereq EXPENSIVE '
1664 test -n "$GIT_TEST_LONG"
1667 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1668 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1671 test_lazy_prereq USR_BIN_TIME '
1672 test -x /usr/bin/time
1675 test_lazy_prereq NOT_ROOT '
1676 uid=$(id -u) &&
1677 test "$uid" != 0
1680 test_lazy_prereq JGIT '
1681 jgit --version
1684 # SANITY is about "can you correctly predict what the filesystem would
1685 # do by only looking at the permission bits of the files and
1686 # directories?" A typical example of !SANITY is running the test
1687 # suite as root, where a test may expect "chmod -r file && cat file"
1688 # to fail because file is supposed to be unreadable after a successful
1689 # chmod. In an environment (i.e. combination of what filesystem is
1690 # being used and who is running the tests) that lacks SANITY, you may
1691 # be able to delete or create a file when the containing directory
1692 # doesn't have write permissions, or access a file even if the
1693 # containing directory doesn't have read or execute permissions.
1695 test_lazy_prereq SANITY '
1696 mkdir SANETESTD.1 SANETESTD.2 &&
1698 chmod +w SANETESTD.1 SANETESTD.2 &&
1699 >SANETESTD.1/x 2>SANETESTD.2/x &&
1700 chmod -w SANETESTD.1 &&
1701 chmod -r SANETESTD.1/x &&
1702 chmod -rx SANETESTD.2 ||
1703 BUG "cannot prepare SANETESTD"
1705 ! test -r SANETESTD.1/x &&
1706 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1707 status=$?
1709 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1710 rm -rf SANETESTD.1 SANETESTD.2 ||
1711 BUG "cannot clean SANETESTD"
1712 return $status
1715 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1716 GIT_UNZIP=${GIT_UNZIP:-unzip}
1717 test_lazy_prereq UNZIP '
1718 "$GIT_UNZIP" -v
1719 test $? -ne 127
1722 run_with_limited_cmdline () {
1723 (ulimit -s 128 && "$@")
1726 test_lazy_prereq CMDLINE_LIMIT '
1727 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1728 run_with_limited_cmdline true
1731 run_with_limited_stack () {
1732 (ulimit -s 128 && "$@")
1735 test_lazy_prereq ULIMIT_STACK_SIZE '
1736 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1737 run_with_limited_stack true
1740 run_with_limited_open_files () {
1741 (ulimit -n 32 && "$@")
1744 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1745 test_have_prereq !MINGW,!CYGWIN &&
1746 run_with_limited_open_files true
1749 build_option () {
1750 git version --build-options |
1751 sed -ne "s/^$1: //p"
1754 test_lazy_prereq SIZE_T_IS_64BIT '
1755 test 8 -eq "$(build_option sizeof-size_t)"
1758 test_lazy_prereq LONG_IS_64BIT '
1759 test 8 -le "$(build_option sizeof-long)"
1762 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1763 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1765 test_lazy_prereq CURL '
1766 curl --version
1769 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1770 # which will not work with other hash algorithms and tests that work but don't
1771 # test anything meaningful (e.g. special values which cause short collisions).
1772 test_lazy_prereq SHA1 '
1773 case "$GIT_DEFAULT_HASH" in
1774 sha1) true ;;
1775 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1776 *) false ;;
1777 esac
1780 # Ensure that no test accidentally triggers a Git command
1781 # that runs the actual maintenance scheduler, affecting a user's
1782 # system permanently.
1783 # Tests that verify the scheduler integration must set this locally
1784 # to avoid errors.
1785 GIT_TEST_MAINT_SCHEDULER="none:exit 1"